/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/dynpmc/rational.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_rational.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/dynpmc/rational.pmc"
/*
Copyright (C) 2008-2011, Parrot Foundation.

=pod

=head1 NAME

src/dynpmc/rational.pmc - Rational numbers PMC

=head1 DESCRIPTION

Rational is currently going to get implemented. It uses the GNU Multiple Precision (GMP) library,
like BigInt, because implementation with integers would be too unstable and inaccurate.

'LispRational' will subclass this.

You may use Rational with any of parrot's basic data types as well as with String-, Integer- and
Float-PMCs.

=head1 Functions

Currently C<rational.pmc> only has some C<static> functions for code sharing.

=over 4

=cut

*/

#include "parrot/has_header.h"

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
   typedef struct RATIONAL {
      mpq_t q;
   } RATIONAL;
#  define PMC_rational(x) ((Parrot_Rational_attributes *)PMC_data(x))->rational
#  define RT(x)           ((Parrot_Rational_attributes *)PMC_data(x))->rational->q
#else
#  define RT(x)
#endif

#define RAISE_EXCEPTION   Parrot_ex_throw_from_c_args(interp, NULL, \
    EXCEPTION_LIBRARY_NOT_LOADED, "GNU Multiple Precision library not found.");

/*

=item C<static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base)>

Returns a string representation of a Rational-PMC to a certain base.

=cut

*/
static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base) {
  #ifdef PARROT_HAS_GMP
    char * const cstr   = mpq_get_str(NULL, (int) base, RT(self));
    STRING * const pstr = Parrot_str_new(interp, cstr, 0);
    Parrot_str_free_cstring(cstr);
    return pstr;
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_add_integer(PARROT_INTERP, PMC *self, int value)>

Adds an integer "value" to a Rational-PMC inplace.

=cut

*/
static void rat_add_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;
    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_add(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_add_float(PARROT_INTERP, PMC *self, double value)>

Adds a float "value" to a Rational-PMC in-place. "value" is first converted to a
rational using GMPs mpq_set_d-function. This is meant to be exact.

=cut

*/
static void rat_add_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_add(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value)>

Multiplies a Rational-PMC with an integer "value" in-place.

=cut

*/
static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpz_mul_ui(mpq_numref(RT(self)), mpq_numref(RT(self)), (unsigned int) value);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_multiply_float(PARROT_INTERP, PMC *self, double value)>

Multiplies a Rational-PMC with a float "value" in-place.

=cut

*/
static void rat_multiply_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_mul(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_divide_integer(PARROT_INTERP, PMC *self, int value)>

Divides a Rational-PMC through an integer "value" in-place.

=cut

*/
static void rat_divide_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_div(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item C<static void rat_divide_float(PARROT_INTERP, PMC *self, double value)>

Divides a Rational-PMC through a float "value" in-place.

=cut

*/
static void rat_divide_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_div(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=back

=cut

*/
#line 225 "./src/dynpmc/rational.c"
static  PMC  * Parrot_Rational_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  PMC  * Parrot_Rational_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_Rational_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_decrement(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Rational_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  INTVAL  Parrot_Rational_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Rational_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Rational_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Rational_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Rational_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base);
static  void  Parrot_Rational_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_neg(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_increment(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Rational_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_Rational_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  void  Parrot_Rational_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value);
static  void  Parrot_Rational_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  PMC  * Parrot_Rational_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  void Parrot_Rational_nci_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Rational_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_add_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_add_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Rational_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_subtract_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_subtract_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Rational_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_multiply_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_multiply_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_multiply_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Rational_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_divide_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_divide_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Rational_decrement_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Rational_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Rational_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Rational_set_string_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value);
static  void  Parrot_Rational_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void Parrot_Rational_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_add_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_add_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_add_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_add_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_subtract_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_subtract_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_subtract_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_subtract_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_multiply_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_multiply_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_multiply_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_multiply_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_divide_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_divide_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_divide_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_divide_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_cmp_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_cmp_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_is_equal_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_is_equal_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Rational_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
PARROT_DYNEXT_EXPORT void    Parrot_Rational_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_get_vtable_pointer(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_Rational_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_ro_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_ro_get_vtable_pointer(PARROT_INTERP);
static  PMC  *
Parrot_Rational_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 953 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    mpq_abs(RT(dest), RT(_self));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 379 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 566 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_float(interp, dest, (double) value);
    return dest;
#line 389 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 542 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_integer(interp, dest, (int) value);
    return dest;
#line 399 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 253 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    PMC * const ret = Parrot_pmc_new(interp, _self->vtable->base_type);
    mpq_set(RT(ret), RT(_self));
    return ret;
  #else
    RAISE_EXCEPTION
  #endif
#line 413 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_decrement(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Rational_decrement_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 270 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_clear(RT(_self));
    mem_gc_free(interp, RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 432 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 896 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_divide_float(interp, dest, (double) value);
    return dest;
#line 442 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 872 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_divide_integer(interp, dest, (int) value);
    return dest;
#line 452 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 398 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (mpq_cmp_si(RT(_self), 0, 1) == 0)
        return 0;
    else
        return 1;
  #else
    RAISE_EXCEPTION
  #endif
#line 467 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 355 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_t q;
    mpz_init(q);
    mpz_tdiv_q(q, mpq_numref(RT(_self)), mpq_denref(RT(_self)));
    if (mpz_fits_slong_p(q)) {
        const INTVAL ret = (INTVAL) mpz_get_si(q);
        mpz_clear(q);
        return ret;
    }
    else {
        mpz_clear(q);
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Rational, get_integer(): Number is too big.");
    }
  #else
    RAISE_EXCEPTION
  #endif
#line 491 "./src/dynpmc/rational.c"
}
static  FLOATVAL 
Parrot_Rational_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 382 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    const double d = mpq_get_d(RT(_self));
    return (FLOATVAL) d;
  #else
    RAISE_EXCEPTION
  #endif
#line 504 "./src/dynpmc/rational.c"
}
static  STRING  *
Parrot_Rational_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 415 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, _self, 10);
  #else
    RAISE_EXCEPTION
  #endif
#line 516 "./src/dynpmc/rational.c"
}
static  STRING  *
Parrot_Rational_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base)
{
#line 430 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, _self, (int) base);
  #else
    RAISE_EXCEPTION
  #endif
#line 528 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Rational_i_absolute_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Rational_i_add_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Rational_i_add_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Rational_i_divide_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Rational_i_divide_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Rational_i_multiply_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Rational_i_multiply_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_neg(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Rational_i_neg_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Rational_i_subtract_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Rational_i_subtract_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_increment(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Rational_increment_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Rational_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC  *
Parrot_Rational_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 786 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_multiply_float(interp, dest, (double) value);
    return dest;
#line 610 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 762 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_multiply_integer(interp, dest, (int) value);
    return dest;
#line 620 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 920 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    mpq_neg(RT(dest), RT(_self));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 635 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Rational_set_integer_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Rational_set_number_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value)
{
Parrot_Rational_set_string_keyed_int_orig(interp, _self, base, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Rational_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
Parrot_Rational_set_string_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC  *
Parrot_Rational_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 676 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_float(interp, dest, -((double) value));
    return dest;
#line 669 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 652 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_integer(interp, dest, -((int) value));
    return dest;
#line 679 "./src/dynpmc/rational.c"
}
static  void
Parrot_Rational_nci_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 690 "./src/dynpmc/rational.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 219 "./src/dynpmc/rational.pmc"

    STRING *version;
  #ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
  #else
    version = Parrot_str_new(interp, "0.0.0", 0);
  #endif
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)version);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *version */
    }
#line 226 "./src/dynpmc/rational.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 726 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 479 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_integer(interp, dest, VTABLE_get_integer(interp, value));
    return dest;
#line 736 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 485 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_float(interp, dest, VTABLE_get_number(interp, value));
    return dest;
#line 746 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 491 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    mpq_add(RT(dest), RT(_self), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 761 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 502 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, add: Not implemented (yet).");
#line 770 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 514 "./src/dynpmc/rational.pmc"

    rat_add_integer(interp, _self, (int) VTABLE_get_integer(interp, value));
#line 778 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 518 "./src/dynpmc/rational.pmc"

    rat_add_float(interp, _self, (double) VTABLE_get_number(interp, value));
#line 786 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 522 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_add(RT(_self), RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 798 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 530 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_add: Not implemented (yet).");
#line 807 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 590 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_integer(interp, dest, -((int) VTABLE_get_integer(interp, value)));
    return dest;
#line 817 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 596 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_add_float(interp, dest, - ((double) VTABLE_get_number(interp, value)));
    return dest;
#line 827 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 602 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);
    mpq_sub(RT(dest), RT(_self), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 841 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 612 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, subtract: Not implemented (yet).");
#line 850 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 624 "./src/dynpmc/rational.pmc"

    rat_add_integer(interp, _self, -((int) VTABLE_get_integer(interp, value)));
#line 858 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 628 "./src/dynpmc/rational.pmc"

    rat_add_float(interp, _self, - ((double) VTABLE_get_number(interp, value)));
#line 866 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 632 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_sub(RT(_self), RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 878 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 640 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_subtract: Not implemented (yet).");
#line 887 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 700 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_multiply_integer(interp, dest, (int) VTABLE_get_integer(interp, value));
    return dest;
#line 897 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 706 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_multiply_float(interp, dest, (double) VTABLE_get_number(interp, value));
    return dest;
#line 907 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 712 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);
    mpq_mul(RT(dest), RT(_self), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 921 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 722 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, multiply: Not implemented (yet).");
#line 930 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 734 "./src/dynpmc/rational.pmc"

    rat_multiply_integer(interp, _self, (int) VTABLE_get_integer(interp, value));
#line 938 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 738 "./src/dynpmc/rational.pmc"

    rat_multiply_float(interp, _self, (double) VTABLE_get_number(interp, value));
#line 946 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 742 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_mul(RT(_self), RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 958 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 750 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_multiply: Not implemented (yet).");
#line 967 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 810 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_divide_integer(interp, dest, (int) VTABLE_get_integer(interp, value));
    return dest;
#line 977 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Float_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 816 "./src/dynpmc/rational.pmc"

    dest = Parrot_Rational_clone(interp, _self);
    rat_divide_float(interp, dest, (double) VTABLE_get_number(interp, value));
    return dest;
#line 987 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Rational_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 822 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, _self->vtable->base_type);
    mpq_div(RT(dest), RT(_self), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 1001 "./src/dynpmc/rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 832 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, divide: Not implemented (yet).");
#line 1010 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 844 "./src/dynpmc/rational.pmc"

    rat_divide_integer(interp, _self, (int) VTABLE_get_integer(interp, value));
#line 1018 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 848 "./src/dynpmc/rational.pmc"

    rat_divide_float(interp, _self, (double) VTABLE_get_number(interp, value));
#line 1026 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 852 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_div(RT(_self), RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1038 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 860 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_divide: Not implemented (yet).");
#line 1047 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 986 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp_si(RT(_self), VTABLE_get_integer(interp, value), 1);
  #else
    RAISE_EXCEPTION
  #endif
#line 1059 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 994 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "This is going to get implemented soon.");
  #else
    RAISE_EXCEPTION
  #endif
#line 1072 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1003 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp(RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1084 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1011 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "cmp not implemented (yet).");
#line 1093 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1023 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    INTVAL eq = 0;
    mpq_t t;
    mpq_init(t);
    mpq_set_ui(t, VTABLE_get_integer(interp, value), 1);

    eq = (INTVAL) mpq_equal(RT(_self), t);
    mpq_clear(t);

    return eq;
  #else
    RAISE_EXCEPTION
  #endif
#line 1113 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1039 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Equality to floats can not be checked because of limited machine "
        "accuracy.\nApproximate the rational and check whether the "
        "difference to a value is lower\nthan an epsilon.");
#line 1124 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Rational(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1046 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_equal(RT(_self), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1136 "./src/dynpmc/rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1054 "./src/dynpmc/rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "is_equal not implemented (yet).");
#line 1145 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_decrement_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 461 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_sub(mpq_numref(RT(_self)), mpq_numref(RT(_self)), mpq_denref(RT(_self)));
    mpq_canonicalize(RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1158 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 971 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_abs(RT(_self), RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1170 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 579 "./src/dynpmc/rational.pmc"

    rat_add_float(interp, _self, (double) value);
#line 1178 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 555 "./src/dynpmc/rational.pmc"

    rat_add_integer(interp, _self, (int) value);
#line 1186 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 909 "./src/dynpmc/rational.pmc"

    rat_divide_float(interp, _self, (double) value);
#line 1194 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 885 "./src/dynpmc/rational.pmc"

    rat_divide_integer(interp, _self, (int) value);
#line 1202 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 799 "./src/dynpmc/rational.pmc"

    rat_multiply_float(interp, _self, (double) value);
#line 1210 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 775 "./src/dynpmc/rational.pmc"

    rat_multiply_integer(interp, _self, (int) value);
#line 1218 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 938 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_neg(RT(_self), RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1230 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 689 "./src/dynpmc/rational.pmc"

    rat_add_float(interp, _self, -((double) value));
#line 1238 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 665 "./src/dynpmc/rational.pmc"

    rat_add_integer(interp, _self, -((int) value));
#line 1246 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 445 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_add(mpq_numref(RT(_self)), mpq_numref(RT(_self)), mpq_denref(RT(_self)));
    mpq_canonicalize(RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1259 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 236 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_Rational_attributes * const attrs =
        PARROT_RATIONAL(_self);
    attrs->rational = mem_gc_allocate_zeroed_typed(interp, RATIONAL);
    mpq_init(RT(_self));
    PObj_custom_destroy_SET(_self);
  #endif
#line 1273 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 286 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_si(RT(_self), (signed int) value, 1);
    mpq_canonicalize(RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1286 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 302 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_d(RT(_self), (double) value);
    mpq_canonicalize(RT(_self));
  #else
    RAISE_EXCEPTION
  #endif
#line 1299 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_set_string_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value)
{
#line 336 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(_self), cstr, (int) base);
    mpq_canonicalize(RT(_self));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 1314 "./src/dynpmc/rational.c"
}
static  void 
Parrot_Rational_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 318 "./src/dynpmc/rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(_self), cstr, 0);
    mpq_canonicalize(RT(_self));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 1329 "./src/dynpmc/rational.c"
}
static  void
Parrot_Rational_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_add_Integer_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_add_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_add_Float_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_add_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_add_Rational_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_add_DEFAULT_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_add_Integer(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_add_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_add_Float(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_add_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_add_Rational(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_add_DEFAULT(interp, _self, value);
}
static  void
Parrot_Rational_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_subtract_Integer_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_subtract_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_subtract_Float_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_subtract_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_subtract_Rational_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_subtract_Integer(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_subtract_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_subtract_Float(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_subtract_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_subtract_Rational(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_subtract_DEFAULT(interp, _self, value);
}
static  void
Parrot_Rational_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_multiply_Integer_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_multiply_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_multiply_Float_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_multiply_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_multiply_Rational_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_multiply_Integer(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_multiply_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_multiply_Float(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_multiply_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_multiply_Rational(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_multiply_DEFAULT(interp, _self, value);
}
static  void
Parrot_Rational_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_divide_Integer_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_divide_Float_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_divide_Float_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_divide_Rational_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_divide_Rational_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC* dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Rational_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "P", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_divide_Integer(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_divide_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_divide_Float(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_divide_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_divide_Rational(interp, _self, value);
}
static  void
Parrot_Rational_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Rational_multi_i_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_Rational_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_cmp_Integer(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_cmp_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_cmp_Float(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_cmp_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_cmp_Rational(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_cmp_DEFAULT(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_is_equal_Integer(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_is_equal_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_is_equal_Float(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_is_equal_Rational_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_is_equal_Rational(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
static  void
Parrot_Rational_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Rational_multi_is_equal_DEFAULT(interp, _self, value);
{
    /*
     * Use the result of Parrot_pcc_build_call_from_c_args because it is marked
     * PARROT_WARN_UNUSED_RESULT. Then explicitly don't use the result.
     * This apparently makes sense.
     */
    PMC *unused = Parrot_pcc_build_call_from_c_args(interp, _call_obj, "I", _result);
    UNUSED(unused);
}
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Rational_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Rational_absolute;
    vt->add_float = Parrot_Rational_add_float;
    vt->add_int = Parrot_Rational_add_int;
    vt->clone = Parrot_Rational_clone;
    vt->decrement = Parrot_Rational_decrement;
    vt->destroy = Parrot_Rational_destroy;
    vt->divide_float = Parrot_Rational_divide_float;
    vt->divide_int = Parrot_Rational_divide_int;
    vt->get_bool = Parrot_Rational_get_bool;
    vt->get_integer = Parrot_Rational_get_integer;
    vt->get_number = Parrot_Rational_get_number;
    vt->get_string = Parrot_Rational_get_string;
    vt->get_string_keyed_int = Parrot_Rational_get_string_keyed_int;
    vt->i_absolute = Parrot_Rational_i_absolute;
    vt->i_add_float = Parrot_Rational_i_add_float;
    vt->i_add_int = Parrot_Rational_i_add_int;
    vt->i_divide_float = Parrot_Rational_i_divide_float;
    vt->i_divide_int = Parrot_Rational_i_divide_int;
    vt->i_multiply_float = Parrot_Rational_i_multiply_float;
    vt->i_multiply_int = Parrot_Rational_i_multiply_int;
    vt->i_neg = Parrot_Rational_i_neg;
    vt->i_subtract_float = Parrot_Rational_i_subtract_float;
    vt->i_subtract_int = Parrot_Rational_i_subtract_int;
    vt->increment = Parrot_Rational_increment;
    vt->init = Parrot_Rational_init;
    vt->multiply_float = Parrot_Rational_multiply_float;
    vt->multiply_int = Parrot_Rational_multiply_int;
    vt->neg = Parrot_Rational_neg;
    vt->set_integer_native = Parrot_Rational_set_integer_native;
    vt->set_number_native = Parrot_Rational_set_number_native;
    vt->set_string_keyed_int = Parrot_Rational_set_string_keyed_int;
    vt->set_string_native = Parrot_Rational_set_string_native;
    vt->subtract_float = Parrot_Rational_subtract_float;
    vt->subtract_int = Parrot_Rational_subtract_int;
    vt->attr_size = sizeof(Parrot_Rational_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Rational_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Rational_absolute;
    vt->add_float = Parrot_Rational_add_float;
    vt->add_int = Parrot_Rational_add_int;
    vt->clone = Parrot_Rational_clone;
    vt->destroy = Parrot_Rational_destroy;
    vt->divide_float = Parrot_Rational_divide_float;
    vt->divide_int = Parrot_Rational_divide_int;
    vt->get_bool = Parrot_Rational_get_bool;
    vt->get_integer = Parrot_Rational_get_integer;
    vt->get_number = Parrot_Rational_get_number;
    vt->get_string = Parrot_Rational_get_string;
    vt->get_string_keyed_int = Parrot_Rational_get_string_keyed_int;
    vt->multiply_float = Parrot_Rational_multiply_float;
    vt->multiply_int = Parrot_Rational_multiply_int;
    vt->neg = Parrot_Rational_neg;
    vt->subtract_float = Parrot_Rational_subtract_float;
    vt->subtract_int = Parrot_Rational_subtract_int;
    vt->attr_size = sizeof(Parrot_Rational_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Rational_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Rational_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Rational_get_vtable_pointer(PARROT_INTERP) {
    STRING *type_name = Parrot_str_new_constant(interp, "Rational");
    INTVAL  type_num  = Parrot_pmc_get_type_str(interp, type_name);
    return interp->vtables[type_num];
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Rational_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Rational_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Rational_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "Rational", 8,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Rational_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Rational")), PMCNULL);
    return isa;
}

void
Parrot_Rational_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":rational ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Rational_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = Parrot_str_new_init(interp, "Rational", 8,
                                       Parrot_ascii_encoding_ptr, PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_concat(interp, vt->provides_str,
            Parrot_str_new_init(interp, "scalar", 6, Parrot_ascii_encoding_ptr,
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_Rational_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Rational_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Rational_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "version");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Rational_nci_version),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "Rational,Integer,PMC");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "Rational");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "Rational,Float,PMC");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "Rational,Rational,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "Rational,DEFAULT,PMC");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "Rational,Integer");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "Rational,Float");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "Rational,Rational");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "Rational,DEFAULT");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "is_equal");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_add_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_add_Float_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_add_Rational_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_add_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_add_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_add_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_add_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_add_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_10, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_subtract_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_subtract_Float_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_subtract_Rational_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_subtract_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_subtract_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_subtract_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_subtract_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_subtract_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_10, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_multiply_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_multiply_Float_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_multiply_Rational_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_multiply_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_multiply_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_multiply_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_multiply_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_multiply_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_10, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_divide_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_divide_Float_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_divide_Rational_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_divide_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_divide_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_divide_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_i_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_10, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_cmp_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_cmp_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_cmp_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_cmp_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_10, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_is_equal_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_is_equal_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_is_equal_Rational_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Rational_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_10, _temp_func);

        }
    } /* pass */
} /* Parrot_Rational_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeRational;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new_constant(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "Rational");
    typeRational = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_Rational_class_init(interp, typeRational, pass);
    }
    return pmc;
}

#line 1057 "./src/dynpmc/rational.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
