/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

Hash PMC wraps Parrot's _hash to provide a high-level API:

=over 4

=item *

Convert between various types to use as hash keys.

=item *

Convert between various types to use as hash values.

=item *

Handle compound Keys for nested Hash/Array lookups.

=item *

Provide C<HashIterator> to iterate over C<Hash>.

=back

By default Hash uses string keys and PMC values. Methods C<set_key_type> and
C<set_value_type> may be used to switch key and values type. For C<PMC> keys
hash value is calculated using VTABLE C<get_hashvalue> function.

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_iterator.h"
#include "pmc/pmc_key.h"
#include "pmc/pmc_hashiteratorkey.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_DOES_NOT_RETURN
static void cannot_autovivify_nested(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_DOES_NOT_RETURN
static void entry_type_must_be_pmc(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC* get_next_hash(PARROT_INTERP,
    ARGIN(const Hash *hash),
    ARGIN(const void *key))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

#define ASSERT_ARGS_cannot_autovivify_nested __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_entry_type_must_be_pmc __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_get_next_hash __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(hash) \
    , PARROT_ASSERT_ARG(key))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static PMC* get_next_hash(PARROT_INTERP, const Hash *hash, const void
*key)>

Get the next hash for multipart keys. Autovivify a hash if it doesn't exist.

=cut

*/

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC*
get_next_hash(PARROT_INTERP, ARGIN(const Hash *hash), ARGIN(const void *key))
{
    ASSERT_ARGS(get_next_hash)
    HashBucket *bucket;

    if (hash->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    bucket = Parrot_hash_get_bucket(interp, hash, key);

    if (bucket)
        return (PMC *)bucket->value;
    else
        return PMCNULL;
}
#line 134 "./src/pmc/hash.c"
static  PMC  * Parrot_Hash_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Hash_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Hash_defined_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_Hash_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_Hash_delete_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_Hash_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Hash_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Hash_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Hash_exists_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_Hash_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  INTVAL  Parrot_Hash_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Hash_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Hash_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  INTVAL  Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  PMC  * Parrot_Hash_get_iter(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Hash_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Hash_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  PMC  * Parrot_Hash_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  * Parrot_Hash_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Hash_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Hash_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Hash_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  STRING  * Parrot_Hash_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  STRING  * Parrot_Hash_get_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_Hash_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Hash_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value_type);
static  INTVAL  Parrot_Hash_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Hash_is_same(PARROT_INTERP, ARGMOD(PMC *_self), PMC *other);
static  void  Parrot_Hash_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Hash_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value);
static  void  Parrot_Hash_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type);
static  void  Parrot_Hash_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value);
static  void  Parrot_Hash_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value);
static  void  Parrot_Hash_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value);
static  void  Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value);
static  void  Parrot_Hash_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_Hash_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, STRING *value);
static  void  Parrot_Hash_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  void Parrot_Hash_nci_set_key_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Hash_nci_get_key_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Hash_nci_set_value_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Hash_nci_get_value_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Hash_delete_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_Hash_delete_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_Hash_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Hash_init_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value_type);
static  void  Parrot_Hash_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value);
static  void  Parrot_Hash_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type);
static  void  Parrot_Hash_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value);
static  void  Parrot_Hash_set_number_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value);
static  void  Parrot_Hash_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value);
static  void  Parrot_Hash_set_pmc_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value);
static  void  Parrot_Hash_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_Hash_set_string_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, STRING *value);
static  void  Parrot_Hash_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
void    Parrot_Hash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP);
void    Parrot_Hash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Hash_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 183 "./src/pmc/hash.pmc"

    PMC * const dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    Parrot_hash_clone(interp, (Hash *)VTABLE_get_pointer(interp, _self),
               (Hash *)VTABLE_get_pointer(interp, dest));
    /*
     * Trigger write barrier.
     *
     * If GC was triggered during deep clone of hash than C<dest>
     * will be moved into Gen1 without making it dirty. So, half
     * of keys/values will not be marked during next cycle.
     */
    PARROT_GC_WRITE_BARRIER(interp, dest);

    return dest;
#line 228 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 1012 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = Parrot_hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = Parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = Parrot_key_next(interp, key);

    if (!key)
        return VTABLE_defined(interp, Parrot_hash_value_to_pmc(interp, h, b->value));

    if (h->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    return VTABLE_defined_keyed(interp, (PMC *)b->value, key);
#line 252 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 990 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_string(interp, hash, key));

    /* no such key */
    if (!b)
        return 0;

    return VTABLE_defined(interp, Parrot_hash_value_to_pmc(interp, hash, b->value));
#line 268 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
Parrot_Hash_delete_keyed_orig(interp, _self, key);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_delete_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
Parrot_Hash_delete_keyed_str_orig(interp, _self, key);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 151 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    if (hash)
        Parrot_hash_destroy(interp, hash);
#line 290 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1101 "./src/pmc/hash.pmc"

    return Parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self));
#line 298 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 961 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = Parrot_hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = Parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = Parrot_key_next(interp, key);

    /* lookup stops here */
    if (!key)
        return 1;

    if (h->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    return VTABLE_exists_keyed(interp, (PMC *)b->value, key);
#line 323 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 944 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_string(interp, hash, key));
    return b != NULL;
#line 334 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 1188 "./src/pmc/hash.pmc"

    Parrot_hash_freeze(interp, (Hash *)VTABLE_get_pointer(interp, _self), info);
#line 342 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1087 "./src/pmc/hash.pmc"

    return Parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self)) != 0;
#line 350 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 357 "./src/pmc/hash.pmc"

    return Parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self));
#line 358 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 463 "./src/pmc/hash.pmc"

    const Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    const void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);
    HashBucket * const b        = Parrot_hash_get_bucket(interp, hash, hash_key);

    if (!b)
        return 0;

    key = Parrot_key_next(interp, key);

    /* Stop recursion. This is last step */
    if (!key)
        return Parrot_hash_value_to_int(interp, hash, b->value);

    if (hash->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    /* Recursively call to enclosed aggregate */
    return VTABLE_get_integer_keyed(interp, (PMC *)b->value, key);
#line 383 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 442 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_int(interp, hash, key));

    if (!b)
        return 0;

    return Parrot_hash_value_to_int(interp, hash, b->value);
#line 398 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 431 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_string(interp, hash, key));

    if (!b)
        return 0;

    return Parrot_hash_value_to_int(interp, hash, b->value);
#line 413 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_iter(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1115 "./src/pmc/hash.pmc"

    return Parrot_pmc_new_init(interp, enum_class_HashIterator, _self);
#line 421 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 361 "./src/pmc/hash.pmc"

    return VTABLE_get_integer(interp, _self);
#line 429 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 586 "./src/pmc/hash.pmc"

    const Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);
    HashBucket * const b        = Parrot_hash_get_bucket(interp, hash, hash_key);

    if (!b)
        return 0.0;

    key = Parrot_key_next(interp, key);

    if (!key)
        return Parrot_hash_value_to_number(interp, hash, b->value);

    if (hash->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    return VTABLE_get_number_keyed(interp, (PMC *)b->value, key);
#line 452 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 565 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_int(interp, hash, key));

    if (!b)
        return 0.0;

    return Parrot_hash_value_to_number(interp, hash, b->value);
#line 467 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 554 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_string(interp, hash, key));

    if (!b)
        return 0.0;

    return Parrot_hash_value_to_number(interp, hash, b->value);
#line 482 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 794 "./src/pmc/hash.pmc"

    const Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    const void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);
    HashBucket * const b        = Parrot_hash_get_bucket(interp, hash, hash_key);

    if (!b)
        return PMCNULL;

    key = Parrot_key_next(interp, key);

    /* Stop recursion. This is last step */
    if (!key)
        return Parrot_hash_value_to_pmc(interp, hash, b->value);

    if (hash->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    /* Recursively call to enclosed aggregate */
    return VTABLE_get_pmc_keyed(interp, (PMC *)b->value, key);
#line 507 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 782 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b    = Parrot_hash_get_bucket(interp, hash,
            Parrot_hash_key_from_int(interp, hash, key));

    if (!b)
        return PMCNULL;

    return Parrot_hash_value_to_pmc(interp, hash, b->value);
#line 522 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 761 "./src/pmc/hash.pmc"

    const Hash *hash;
    HashBucket *b;

    GETATTR_Hash_hash(interp, _self, hash);

    if (!hash->entries)
        return PMCNULL;

    b = Parrot_hash_get_bucket(interp, hash, key);

    if (!b)
        return PMCNULL;

    /* special case the most likely value type, for speed */
    if (hash->entry_type == enum_type_PMC)
        return (PMC *)b->value;
    else
        return Parrot_hash_value_to_pmc(interp, hash, b->value);
#line 547 "./src/pmc/hash.c"
}
static  void  *
Parrot_Hash_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 341 "./src/pmc/hash.pmc"

    return PARROT_HASH(_self)->hash;
#line 555 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 384 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, _self);
    PMC * const sb   = Parrot_pmc_new(interp, enum_class_StringBuilder);
    const INTVAL n   = VTABLE_elements(interp, _self);
    INTVAL       j;

    VTABLE_push_string(interp, sb, CONST_STRING(interp, "{"));

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        INTVAL         len = STRING_length(key);
        INTVAL         idx;
        PMC           *val;

        idx = STRING_find_not_cclass(interp, enum_cclass_numeric,
                                     key, 0, len);

        if (idx >= len) {
            /* Only digits */
            VTABLE_push_string(interp, sb, key);
        }
        else {
            VTABLE_push_string(interp, sb, CONST_STRING(interp, "'"));
            VTABLE_push_string(interp, sb, key);
            VTABLE_push_string(interp, sb, CONST_STRING(interp, "'"));
        }
        VTABLE_push_string(interp, sb, CONST_STRING(interp, ":"));
        val = VTABLE_get_pmc_keyed_str(interp, _self, key);
        VTABLE_push_string(interp, sb, VTABLE_get_string(interp, val));

        if (j < n - 1)
            VTABLE_push_string(interp, sb, CONST_STRING(interp, ", "));
    }

    return VTABLE_get_string(interp, sb);
#line 596 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 380 "./src/pmc/hash.pmc"

    return Parrot_sprintf_c(interp, "Hash[0x%x]", _self);
#line 604 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 649 "./src/pmc/hash.pmc"

    const Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    const void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);
    HashBucket * const b        = Parrot_hash_get_bucket(interp, hash, hash_key);

    if (!b)
        return CONST_STRING(interp, "");

    key = Parrot_key_next(interp, key);

    /* Stop recursion. This is last step */
    if (!key)
        return Parrot_hash_value_to_string(interp, hash, b->value);

    if (hash->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    /* Recursively call to enclosed aggregate */
    return VTABLE_get_string_keyed(interp, (PMC *)b->value, key);
#line 629 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 628 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b =
        Parrot_hash_get_bucket(interp, hash, Parrot_hash_key_from_int(interp, hash, key));

    if (!b)
        return CONST_STRING(interp, "");

    return Parrot_hash_value_to_string(interp, hash, b->value);
#line 644 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 616 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b =
        Parrot_hash_get_bucket(interp, hash, Parrot_hash_key_from_string(interp, hash, key));

    /* XXX: shouldn't we return STRINGNULL? */
    if (!b)
        return CONST_STRING(interp, "");

    return Parrot_hash_value_to_string(interp, hash, b->value);
#line 660 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Hash_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value_type)
{
Parrot_Hash_init_int_orig(interp, _self, value_type);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  INTVAL 
Parrot_Hash_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1146 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, _self);
    INTVAL      j, n;

    if (value->vtable->base_type != _self->vtable->base_type)
        return 0;

    n = VTABLE_elements(interp, _self);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC           *item1, *item2;

        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;

        item1 = VTABLE_get_pmc_keyed_str(interp, _self, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);

        if (item1 == item2)
            continue;

        if (!VTABLE_is_equal(interp, item1, item2))
            return 0;
    }

    return 1;
#line 708 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_is_same(PARROT_INTERP, ARGMOD(PMC *_self), PMC *other)
{
#line 1129 "./src/pmc/hash.pmc"

    return (INTVAL)(other->vtable == _self->vtable &&
        VTABLE_get_pointer(interp, other) == VTABLE_get_pointer(interp, _self));
#line 717 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 167 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    if (hash && hash->entries)
        Parrot_hash_mark(interp, hash);
#line 727 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value)
{
Parrot_Hash_set_integer_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
Parrot_Hash_set_integer_keyed_int_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value)
{
Parrot_Hash_set_integer_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type)
{
Parrot_Hash_set_integer_native_orig(interp, _self, type);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value)
{
Parrot_Hash_set_number_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value)
{
Parrot_Hash_set_number_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value)
{
Parrot_Hash_set_pmc_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value)
{
Parrot_Hash_set_pmc_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
Parrot_Hash_set_pointer_orig(interp, _self, ptr);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value)
{
Parrot_Hash_set_string_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, STRING *value)
{
Parrot_Hash_set_string_keyed_int_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_set_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, STRING *value)
{
Parrot_Hash_set_string_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Hash_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
Parrot_Hash_thaw_orig(interp, _self, info);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Hash_nci_set_key_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 816 "./src/pmc/hash.pmc"
INTVAL type;

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &type);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 267 "./src/pmc/hash.pmc"

    _self->vtable->set_integer_native(interp, _self, type);
#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 835 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_key_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 846 "./src/pmc/hash.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 280 "./src/pmc/hash.pmc"

    const INTVAL ret = ((Hash *)_self->vtable->get_pointer(interp, _self))->key_type;
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL ret */
    }
#line 282 "./src/pmc/hash.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 877 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_set_value_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 888 "./src/pmc/hash.pmc"
INTVAL type;

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &type);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 296 "./src/pmc/hash.pmc"

    Hash * const old_hash = (Hash *)_self->vtable->get_pointer(interp, _self);
    Hash *new_hash;

    /*
    If someone called Hash.set_pointer with NULL pointer...
    It will create STRING* keys hash.
    */

    if (old_hash && old_hash->entry_type == type)
        return;

    switch (type) {
      case enum_type_INTVAL:
      case enum_type_STRING:
      case enum_type_PMC:
        new_hash = Parrot_hash_create(interp,
                    (PARROT_DATA_TYPE)type,
                    old_hash ? old_hash->key_type : Hash_key_type_STRING);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type %d", type);
    }

    PARROT_HASH(_self)->hash = new_hash;

    if (old_hash)
        Parrot_hash_destroy(interp, old_hash);
#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 934 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_value_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 945 "./src/pmc/hash.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 327 "./src/pmc/hash.pmc"

    const INTVAL ret = ((Hash *)_self->vtable->get_pointer(interp, _self))->entry_type;
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL ret */
    }
#line 329 "./src/pmc/hash.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 976 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 1055 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = Parrot_hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = Parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return;

    key = Parrot_key_next(interp, key);

    if (!key) {
        Parrot_hash_delete(interp, h, sx);
        return;
    }

    if (h->entry_type != enum_type_PMC)
        entry_type_must_be_pmc(interp);

    VTABLE_delete_keyed(interp, (PMC *)b->value, key);
#line 1002 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 1040 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    Parrot_hash_delete(interp, hash, Parrot_hash_key_from_string(interp, hash, key));
#line 1011 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 133 "./src/pmc/hash.pmc"

    Parrot_Hash_attributes * const attr =
        (Parrot_Hash_attributes *) PMC_data(_self);

    attr->hash            = Parrot_hash_new(interp);
    PObj_custom_mark_destroy_SETALL(_self);
#line 1023 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value_type)
{
#line 141 "./src/pmc/hash.pmc"

    Parrot_Hash_attributes * const attr =
        (Parrot_Hash_attributes *) PMC_data(_self);

    attr->hash = Parrot_hash_create(interp,
            (PARROT_DATA_TYPE)value_type,
            Hash_key_type_STRING);
    PObj_custom_mark_destroy_SETALL(_self);
#line 1037 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value)
{
#line 492 "./src/pmc/hash.pmc"

    Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);

    if (PObj_constant_TEST(_self)
    && !PObj_constant_TEST((const PObj *)key))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Used non-constant PMC key in constant hash.");

    key = Parrot_key_next(interp, key);

    if (!key) {
        Parrot_hash_put(interp, hash, hash_key,
                Parrot_hash_value_from_int(interp, hash, value));
    }
    else {
        PMC * const next_hash = get_next_hash(interp, hash, hash_key);
        if (PMC_IS_NULL(next_hash))
            cannot_autovivify_nested(interp);
        VTABLE_set_integer_keyed(interp, next_hash, key, value);
    }
#line 1065 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
#line 516 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    Parrot_hash_put(interp, hash, Parrot_hash_key_from_int(interp, hash, key),
            Parrot_hash_value_from_int(interp, hash, value));
#line 1075 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value)
{
#line 530 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    if (PObj_constant_TEST(_self)
    && !PObj_constant_TEST((PObj *)key))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Used non-constant key in constant hash.");

    Parrot_hash_put(interp, hash, Parrot_hash_key_from_string(interp, hash, key),
            Parrot_hash_value_from_int(interp, hash, value));
#line 1092 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type)
{
#line 235 "./src/pmc/hash.pmc"

    Hash            *new_hash;
    Hash * const     old_hash   = PARROT_HASH(_self)->hash;
    PARROT_DATA_TYPE entry_type = old_hash
                                ? old_hash->entry_type
                                : enum_type_PMC;

    switch (type) {
      case Hash_key_type_int:
      case Hash_key_type_STRING:
      case Hash_key_type_PMC:
      case Hash_key_type_PMC_ptr:
      case Hash_key_type_STRING_enc:
        new_hash = Parrot_hash_create(interp,
                entry_type,
                (Hash_key_type)type);
        break;

      default:
        /* We probably will not implement other types of keys. They are way
         * too dangerous to use from PIR */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Hash: Unknown key type");
    }


    PARROT_HASH(_self)->hash = new_hash;

    if (old_hash)
        Parrot_hash_destroy(interp, old_hash);
#line 1128 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value)
{
#line 823 "./src/pmc/hash.pmc"

    Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);

    if (PObj_constant_TEST(_self)
    && !PObj_constant_TEST((PObj *)key))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Used non-constant PMC key in constant hash.");

    key = Parrot_key_next(interp, key);

    if (!key) {
        Parrot_hash_put(interp, hash, hash_key,
                Parrot_hash_value_from_number(interp, hash, value));
    }
    else {
        PMC * const next_hash = get_next_hash(interp, hash, hash_key);
        if (PMC_IS_NULL(next_hash))
            cannot_autovivify_nested(interp);
        VTABLE_set_number_keyed(interp, next_hash, key, value);
    }
#line 1156 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value)
{
#line 857 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    if (PObj_constant_TEST(_self)
    && !PObj_constant_TEST((PObj *)key))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Used non-constant STRING key in constant hash.");

    Parrot_hash_put(interp, hash, Parrot_hash_key_from_string(interp, hash, key),
            Parrot_hash_value_from_number(interp, hash, value));
#line 1173 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value)
{
#line 878 "./src/pmc/hash.pmc"

    Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);

    if (PObj_constant_TEST(_self)) {
        if (!PObj_constant_TEST((PObj *)key))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant PMC key in constant hash.");

        if (!PObj_constant_TEST((PObj *)value))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant PMC value in constant hash.");
    }

    key = Parrot_key_next(interp, key);

    if (!key) {
        Parrot_hash_put(interp, hash, hash_key, value);
    }
    else {
        PMC * const next_hash = get_next_hash(interp, hash, hash_key);
        if (PMC_IS_NULL(next_hash))
            cannot_autovivify_nested(interp);
        VTABLE_set_pmc_keyed(interp, next_hash, key, value);
    }
#line 1206 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value)
{
#line 917 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    if (PObj_constant_TEST(_self)) {
        if (!PObj_constant_TEST((PObj *)key))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant STRING key in constant hash.");

        if (!PObj_constant_TEST((PObj *)value))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant STRING value in constant hash.");
    }

    Parrot_hash_put(interp, hash, Parrot_hash_key_from_string(interp, hash, key),
            Parrot_hash_value_from_pmc(interp, hash, value));
#line 1229 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
#line 210 "./src/pmc/hash.pmc"

    Hash * const old_hash = (Hash *)VTABLE_get_pointer(interp, _self);
    Hash * const new_hash = (Hash *)ptr;

    PARROT_HASH(_self)->hash = new_hash;

    if (old_hash)
        Parrot_hash_destroy(interp, old_hash);
#line 1243 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value)
{
#line 678 "./src/pmc/hash.pmc"

    Hash * const hash     = (Hash *)VTABLE_get_pointer(interp, _self);
    void * const hash_key = Parrot_hash_key_from_pmc(interp, hash, key);

    if (PObj_constant_TEST(_self)){
        if (!PObj_constant_TEST((PObj *)key))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant PMC key in constant hash.");
        if (!PObj_constant_TEST((PObj *)value))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant STRING value in constant hash.");
    }

    key = Parrot_key_next(interp, key);

    if (!key) {
        Parrot_hash_put(interp, hash, hash_key,
                Parrot_hash_value_from_string(interp, hash, value));
    }
    else {
        PMC * const next_hash = get_next_hash(interp, hash, hash_key);
        if (PMC_IS_NULL(next_hash))
            cannot_autovivify_nested(interp);
        VTABLE_set_string_keyed(interp, next_hash, key, value);
    }
#line 1276 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, STRING *value)
{
#line 733 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    if ((PObj_constant_TEST(_self))
    && (!PObj_constant_TEST((PObj *)value)))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Used non-constant STRING value in constant hash.");

    Parrot_hash_put(interp, hash,
            Parrot_hash_key_from_int(interp, hash, key),
            Parrot_hash_value_from_string(interp, hash, value));
#line 1294 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, STRING *value)
{
#line 715 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    if (PObj_constant_TEST(_self)){
        if (!PObj_constant_TEST((PObj *)key))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant STRING key in constant hash.");
        if (!PObj_constant_TEST((PObj *)value))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Used non-constant STRING value in constant hash.");
    }

    Parrot_hash_put(interp, hash, Parrot_hash_key_from_string(interp, hash, key),
            Parrot_hash_value_from_string(interp, hash, value));
#line 1316 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 1202 "./src/pmc/hash.pmc"

    VTABLE_set_pointer(interp, _self, (void *)Parrot_hash_thaw(interp, info));
    /* Thawed Hash was created from pmc_new_noinit */
    PObj_custom_mark_destroy_SETALL(_self);
#line 1326 "./src/pmc/hash.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Hash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->delete_keyed = Parrot_Hash_delete_keyed;
    vt->delete_keyed_str = Parrot_Hash_delete_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->init = Parrot_Hash_init;
    vt->init_int = Parrot_Hash_init_int;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->set_integer_keyed = Parrot_Hash_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_Hash_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_Hash_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Hash_set_integer_native;
    vt->set_number_keyed = Parrot_Hash_set_number_keyed;
    vt->set_number_keyed_str = Parrot_Hash_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_Hash_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_Hash_set_pmc_keyed_str;
    vt->set_pointer = Parrot_Hash_set_pointer;
    vt->set_string_keyed = Parrot_Hash_set_string_keyed;
    vt->set_string_keyed_int = Parrot_Hash_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_Hash_set_string_keyed_str;
    vt->thaw = Parrot_Hash_thaw;
    vt->attr_size = sizeof(Parrot_Hash_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->attr_size = sizeof(Parrot_Hash_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Hash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Hash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Hash_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "Hash", 4,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Hash_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Hash")), PMCNULL);
    return isa;
}

void
Parrot_Hash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Hash_get_vtable(interp);
        vt->base_type      = enum_class_Hash;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Hash");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_Hash_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Hash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Hash;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Hash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "set_key_type");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Hash_nci_set_key_type),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_key_type");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Hash_nci_get_key_type),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "set_value_type");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Hash_nci_set_value_type),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_value_type");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Hash_nci_get_value_type),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Hash_class_init */
#line 1206 "./src/pmc/hash.pmc"


/*

=back

=head1 Auxiliar functions

=over 4

=item C<static void entry_type_must_be_pmc(PARROT_INTERP)>

=item C<static void cannot_autovivify_nested(PARROT_INTERP)>

*/

PARROT_DOES_NOT_RETURN
static void
entry_type_must_be_pmc(PARROT_INTERP)
{
    ASSERT_ARGS(entry_type_must_be_pmc)
    Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Hash entry type must be PMC for multipart keys.");
}

PARROT_DOES_NOT_RETURN
static void
cannot_autovivify_nested(PARROT_INTERP)
{
    ASSERT_ARGS(cannot_autovivify_nested)
    Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Cannot autovivify nested hashes");
}

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
