/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/structview.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_structview.h"
#include "pmc_default.h"
#include "structview.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/structview.pmc"
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/structview.pmc - C struct view for pointers.

=head1 DESCRIPTION

PMC class to view pointers as C C<struct>s. This includes read, write, allocate,
and deallocate operations. Bounds checking is implemented where the pointer
class reports a non-zero bound. Recursive definition through nesting is not
supported but can be emulated by interpreting pointer or buffer elements as
structs once dereferenced.

Elements are get/set using keyed access of the form C<[Ptr; Idx]>, which will
interpret the C<Ptr> PMC and lookup the C<Idx>'th element.

=head2 Vtables and Methods

=over 4

=cut

*/

#include "pmc/pmc_ptrobj.h"

#define ALIGN_UP(addr, align) (((addr) + ((align) - 1)) & ~((align) - 1))

#define MAX(x, y) ((y) > (x) ? (y) : (x))

#define BEGIN_KEYED(interp, s, k)                                  \
    size_t      n_elts;                                            \
    elt_desc_t *elts;                                              \
    PMC        *ptr_pmc;                                           \
    void       *ptr, *base_ptr;                                    \
    INTVAL      i;                                                 \
    PMC        *orig_k = (k);                                      \
    GETATTR_StructView_n_elts((interp), (s), n_elts);              \
    GETATTR_StructView_elts((interp), (s), elts);                  \
    ptr_pmc = Parrot_key_pmc((interp), (k));                       \
    (k)     = Parrot_key_next((interp), (k));                      \
    i       = Parrot_key_integer((interp), (k));                   \
    (k)     = orig_k;                                              \
    if (i < 0 || n_elts <= i)                                      \
        Parrot_ex_throw_from_c_args((interp), NULL, 0,             \
                "Struct index out of bounds (%d)",                 \
                i);                                                \
    base_ptr = VTABLE_get_pointer((interp), ptr_pmc);              \
    ptr      = ((char *)base_ptr) + elts[i].byte_offset;           \
    /* guard against null pointer dereference */                   \
    if (!base_ptr)                                                 \
        Parrot_ex_throw_from_c_args((interp), NULL, 0,             \
                "Attempt to derefrence null pointer");             \
    /* guard against out of bounds access */                       \
    {                                                              \
        size_t buf_size = VTABLE_get_integer((interp), ptr_pmc);   \
        size_t self_size;                                          \
        GETATTR_StructView_size((interp), (s), self_size);         \
        if (buf_size && buf_size < self_size)                      \
            Parrot_ex_throw_from_c_args((interp), NULL, 0,         \
                    "Buffer length too small for struct "          \
                        "(at least %d required, got %d)",          \
                    self_size, buf_size);                          \
    }                                                              \
    /* guard against unaligned access */                           \
    {                                                              \
        size_t align;                                              \
        GETATTR_StructView_align((interp), (s), align);            \
        if ((size_t)base_ptr != ALIGN_UP((size_t)base_ptr, align)) \
            Parrot_ex_throw_from_c_args((interp), NULL, 0,         \
                    "Attempt to dereference unaligned pointer "    \
                        "(%x, required alignment: %d)",            \
                    base_ptr, align);                              \
    }

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void deallocate_ptrobj(SHIM_INTERP,
    SHIM(PMC *obj),
    ARGFREE(void *ptr));

#define ASSERT_ARGS_deallocate_ptrobj __attribute__unused__ int _ASSERT_ARGS_CHECK = (0)
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void deallocate_ptrobj(PARROT_INTERP, PMC *obj, void *ptr)>

Deallocation function to be attached to allocated instances.

=cut

*/

static void
deallocate_ptrobj(SHIM_INTERP, SHIM(PMC *obj), ARGFREE(void *ptr))
{
    ASSERT_ARGS(deallocate_ptrobj)
    mem_sys_free(ptr);
}
#line 129 "./src/pmc/structview.c"
static  void  Parrot_StructView_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StructView_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v);
static  INTVAL  Parrot_StructView_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_StructView_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k);
static  FLOATVAL  Parrot_StructView_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k);
static  PMC  * Parrot_StructView_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k);
static  STRING  * Parrot_StructView_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k);
static  void  Parrot_StructView_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StructView_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p);
static  void  Parrot_StructView_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, INTVAL x);
static  void  Parrot_StructView_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, FLOATVAL n);
static  void  Parrot_StructView_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, PMC *p);
static  void  Parrot_StructView_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, STRING *s);
static  void  Parrot_StructView_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v);
static  void Parrot_StructView_nci_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_align(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_aligned_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_alloc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_array_offs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_elt_offs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StructView_nci_get_shape(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StructView_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StructView_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p);
static  void  Parrot_StructView_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, INTVAL x);
static  void  Parrot_StructView_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, FLOATVAL n);
static  void  Parrot_StructView_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, PMC *p);
static  void  Parrot_StructView_set_string_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, STRING *s);
static  void  Parrot_StructView_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v);
void    Parrot_StructView_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StructView_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StructView_get_vtable(PARROT_INTERP);
void    Parrot_StructView_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StructView_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StructView_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_StructView_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 442 "./src/pmc/structview.pmc"

    elt_desc_t *elts;
    GETATTR_StructView_elts(interp, _self, elts);
    mem_gc_free(interp, elts);
#line 172 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v)
{
#line 1088 "./src/pmc/structview.pmc"

    PMC *shape;
    Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING(interp, "get_shape"),
            "->P", &shape);
    VTABLE_freeze(interp, shape, v);
#line 183 "./src/pmc/structview.c"
}
static  INTVAL 
Parrot_StructView_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 832 "./src/pmc/structview.pmc"

    size_t size;
    GETATTR_StructView_size(interp, _self, size);
    return size;
#line 193 "./src/pmc/structview.c"
}
static  INTVAL 
Parrot_StructView_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k)
{
#line 460 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case int_access:
        switch (elts[i].type) {
#define CASE_RET2(type, name) \
          case enum_type_  ## name: return *(type *)ptr;
#define CASE_RET1(type) \
            CASE_RET2(type, type) \
            CASE_RET2(unsigned type, u ## type)
            CASE_RET2(INTVAL, INTVAL)
            CASE_RET1(char);
            CASE_RET1(short);
            CASE_RET1(int);
            CASE_RET1(long);
#if PARROT_HAS_LONGLONG
            CASE_RET2(long long,          longlong);
            CASE_RET2(unsigned long long, ulonglong);
#endif
            CASE_RET2(Parrot_Int1,  int8);
            CASE_RET2(Parrot_UInt1, uint8);
            CASE_RET2(Parrot_Int2,  int16);
            CASE_RET2(Parrot_UInt2, uint16);
            CASE_RET2(Parrot_Int4,  int32);
            CASE_RET2(Parrot_UInt4, uint32);
#if PARROT_HAS_INT64
            CASE_RET2(Parrot_Int8,  int64);
            CASE_RET2(Parrot_UInt8, uint64);
#endif
#undef CASE_RET1
#undef CASE_RET2
          default:
              break;
        }
        break;
      case unaligned_access:
        {
            INTVAL           acc      = 0;
            size_t           bits, n;
            unsigned char   *cptr     = (unsigned char *)ptr;

            switch (elts[i].type) {
              case enum_type_uint1:
                bits = 1;
                break;
              case enum_type_uint4:
                bits = 4;
                break;
              default:
                bits = 8 * data_types[elts[i].type - enum_first_type].size;
                break;
            }

            /* fetch hi bits of first byte */
            acc = *cptr++ >> elts[i].bit_offset;
            n   = 8       -  elts[i].bit_offset;

            /* read whole bytes until complete */
            while (n < bits) {
                acc |= ((UINTVAL)*cptr++) << n;
                n   += 8;
            }

            /* mask off hi bits of last byte */
            acc &= (~(UINTVAL)0) >> (sizeof (UINTVAL) * 8 - bits);

            return acc;
        }
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid integer type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 273 "./src/pmc/structview.c"
}
static  FLOATVAL 
Parrot_StructView_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k)
{
#line 630 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case num_access:
        switch (elts[i].type) {
          case enum_type_FLOATVAL:
            return *(FLOATVAL *)ptr;
          case enum_type_float:
            return *(float *)ptr;
          case enum_type_double:
            return *(double *)ptr;
          case enum_type_longdouble:
            return *(long double *)ptr;
          default:
              break;
        }
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid number type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 300 "./src/pmc/structview.c"
}
static  PMC  *
Parrot_StructView_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k)
{
#line 740 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case int_access:
      case unaligned_access:
        return Parrot_pmc_box_integer(interp, VTABLE_get_integer_keyed(interp, _self, k));
      case num_access:
        return Parrot_pmc_box_number(interp, VTABLE_get_number_keyed(interp, _self, k));
      case str_access:
        return Parrot_pmc_box_string(interp, VTABLE_get_string_keyed(interp, _self, k));
      case pmc_access:
        {
            PMC *ret;
            switch (elts[i].type) {
              case enum_type_PMC:
                return *(PMC **)ptr;
              case enum_type_func_ptr:
              case enum_type_ptr:
                return Parrot_pmc_new_init_int(interp, enum_class_Ptr,
                        (INTVAL)*(void **)ptr);
              case enum_type_sized:
                ret = Parrot_pmc_new_init_int(interp, enum_class_PtrBuf,
                        (INTVAL)*(void **)ptr);
                VTABLE_set_integer_native(interp, ret, elts[i].size);
                return ret;
              default:
                  break;
            }
        }
      default:
          break;
    }
#line 338 "./src/pmc/structview.c"
}
static  STRING  *
Parrot_StructView_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k)
{
#line 692 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case str_access:
        switch (elts[i].type) {
          case enum_type_STRING:
            return *(STRING **)ptr;
          default:
              break;
        }
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid string type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 359 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_StructView_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p)
{
Parrot_StructView_init_pmc_orig(interp, _self, p);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, INTVAL x)
{
Parrot_StructView_set_integer_keyed_orig(interp, _self, k, x);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, FLOATVAL n)
{
Parrot_StructView_set_number_keyed_orig(interp, _self, k, n);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, PMC *p)
{
Parrot_StructView_set_pmc_keyed_orig(interp, _self, k, p);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, STRING *s)
{
Parrot_StructView_set_string_keyed_orig(interp, _self, k, s);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StructView_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v)
{
Parrot_StructView_thaw_orig(interp, _self, v);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_StructView_nci_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 412 "./src/pmc/structview.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 838 "./src/pmc/structview.pmc"

    size_t size;
    GETATTR_StructView_size(interp, _self, size);
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL size */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)size);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL size */
    }
#line 841 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 444 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_align(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 455 "./src/pmc/structview.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 854 "./src/pmc/structview.pmc"

    size_t align;
    GETATTR_StructView_align(interp, _self, align);
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL align */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)align);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL align */
    }
#line 857 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 487 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_aligned_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 498 "./src/pmc/structview.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 871 "./src/pmc/structview.pmc"

    size_t size, align;
    INTVAL ret;
    GETATTR_StructView_size(interp, _self, size);
    GETATTR_StructView_align(interp, _self, align);
    ret = ALIGN_UP(size, align);
    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL ret */
    }
#line 877 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 533 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_alloc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 544 "./src/pmc/structview.pmc"
INTVAL n;
INTVAL has_n;

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &_self, &n, &has_n);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 890 "./src/pmc/structview.pmc"

    size_t size, align;
    PMC  *ret;
    void *buf;

    GETATTR_StructView_size(interp, _self, size);

    if (has_n) {
        GETATTR_StructView_align(interp, _self, align);
        size = ALIGN_UP(size, align) * n;
    }

    buf = mem_sys_allocate_zeroed(size);
    ret = Parrot_pmc_new_init_int(interp, enum_class_PtrObj, (INTVAL)buf);
    SETATTR_PtrObj_destroy(interp, ret, deallocate_ptrobj);

    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC ret */
    }
#line 906 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 591 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_array_offs(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 602 "./src/pmc/structview.pmc"
PMC* array;
INTVAL n;

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPI",
            &_self, &array, &n);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 919 "./src/pmc/structview.pmc"

    void   *p          = VTABLE_get_pointer(interp, array);
    INTVAL  array_size = VTABLE_get_integer(interp, array);
    PMC    *ret;
    size_t  size, align;
    GETATTR_StructView_size(interp, _self, size);
    GETATTR_StructView_align(interp, _self, align);

    /* sanity checks */
    if (!p)
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Attempt to dereference null pointer");
    if (array_size && array_size < size * n)
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Buffer length too small for struct array "
                    "(at least %d required, got %d)",
                size * n, array_size);
    if ((size_t)p != ALIGN_UP((size_t)p, align))
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Attempt to dereference unaligned pointer "
                    "(%x, required alignement: %d)",
                p, align);

    size = ALIGN_UP(size, align);
    ret = Parrot_pmc_new_init_int(interp, enum_class_Ptr, (INTVAL)((char *)p + size * n));

    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC ret */
    }
#line 945 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 659 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_elt_offs(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 670 "./src/pmc/structview.pmc"
PMC* array;
INTVAL n;

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPI",
            &_self, &array, &n);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 958 "./src/pmc/structview.pmc"

    void       *p = VTABLE_get_pointer(interp, array);
    PMC        *ret;
    size_t      n_elts;
    elt_desc_t *elts;
    GETATTR_StructView_n_elts(interp, _self, n_elts);
    GETATTR_StructView_elts(interp, _self, elts);

    /* sanity checks */
    if (n < 0 || n_elts <= n)
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Struct index out of bounds (%d)", n);
    if (!p)
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Attempt to dereference null pointer");
    {
        size_t buf_size = VTABLE_get_integer(interp, array);
        size_t self_size;
        GETATTR_StructView_size(interp, _self, self_size);
        if (buf_size && buf_size < self_size)
            Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "Buffer length too small for struct "
                        "(at least %d required, got %d)",
                    self_size, buf_size);
    }
    {
        size_t align;
        GETATTR_StructView_align(interp, _self, align);
        if ((size_t)p != ALIGN_UP((size_t)p, align))
            Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "Attempt to dereference unaligned pointer "
                        "(%x, required alignement: %d)",
                    p, align);
    }

    p   = ((char *)p) + elts[n].byte_offset;
    ret = Parrot_pmc_new_init_int(interp, enum_class_Ptr, (INTVAL)p);

    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC ret */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)ret);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC ret */
    }
#line 996 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 739 "./src/pmc/structview.c"
}
static  void
Parrot_StructView_nci_get_shape(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 750 "./src/pmc/structview.pmc"

#line 374 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 378 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1013 "./src/pmc/structview.pmc"

    int i, j;
    size_t            n;
    elt_desc_t       *elts;
    PARROT_DATA_TYPE  pack_type;
    PMC              *result;

    GETATTR_StructView_n_elts(interp, _self, n);
    GETATTR_StructView_elts(interp, _self, elts);
    GETATTR_StructView_pack_type(interp, _self, pack_type);

    switch (pack_type) {
      case enum_type_struct:
      case enum_type_union:
        result = Parrot_pmc_new_init_int(interp, enum_class_ResizableIntegerArray, n + 2);
        VTABLE_set_integer_keyed_int(interp, result, 0, pack_type);
        VTABLE_set_integer_keyed_int(interp, result, 1, n);
        break;
      case enum_type_sized:
        result = Parrot_pmc_new_init_int(interp, enum_class_ResizableIntegerArray, n * 3 + 4);
        {
            size_t s;
            VTABLE_set_integer_keyed_int(interp, result, 0, pack_type);
            VTABLE_set_integer_keyed_int(interp, result, 1, n);
            GETATTR_StructView_size(interp, _self, s);
            VTABLE_set_integer_keyed_int(interp, result, 2, s);
            GETATTR_StructView_align(interp, _self, s);
            VTABLE_set_integer_keyed_int(interp, result, 3, s);
        }
        break;
      default:
          break;
    }

    for (i = 1, j = 1; i <= n; i++) {
        switch (pack_type) {
          case enum_type_struct:
          case enum_type_union:
            VTABLE_set_integer_keyed_int(interp, result, i + j, elts[i - 1].type);
            if (elts[i - 1].type == enum_type_sized) {
                VTABLE_set_integer_keyed_int(interp, result, i + ++j, elts[i - 1].size);
                VTABLE_set_integer_keyed_int(interp, result, i + ++j, 0);
            }
            break;
          case enum_type_sized:
            VTABLE_set_integer_keyed_int(interp, result, i * 3 + j, elts[i - 1].type);
            if (elts[i - 1].type == enum_type_sized) {
                VTABLE_set_integer_keyed_int(interp, result, i * 3 + ++j, elts[i - 1].size);
                VTABLE_set_integer_keyed_int(interp, result, i * 3 + ++j, 0);
            }
            VTABLE_set_integer_keyed_int(interp,
                                         result, i * 3 + j + 1, elts[i - 1].byte_offset);
            VTABLE_set_integer_keyed_int(interp,
                                         result, i * 3 + j + 2, elts[i - 1].bit_offset);

          default:
              break;
        }
    }

    #line 209 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC result */
#line 218 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)result);
    UNUSED(_ret_object);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC result */
    }
#line 1073 "./src/pmc/structview.pmc"

#line 388 "/builddir/build/BUILD/parrot-3.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
#line 839 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 125 "./src/pmc/structview.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "Meaningless creation of %Ss without initializer",
            _self->vtable->whoami);
#line 849 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p)
{
#line 192 "./src/pmc/structview.pmc"

    const INTVAL      init_len    = VTABLE_elements(interp, p);
    const PARROT_DATA_TYPE pack_type = (PARROT_DATA_TYPE)
                                        VTABLE_get_integer_keyed_int(interp, p, 0);
    const INTVAL      n_elts      = VTABLE_get_integer_keyed_int(interp, p, 1);
    elt_desc_t       *elt_ary;
    size_t            bit_cursor  = 0;
    size_t            byte_cursor = 0;
    size_t            size, align;
    int               incr, i, j;

    switch (pack_type) {
      case enum_type_struct:
      case enum_type_union:
        size  = 0;
        align = 1; /* sorry, no sub-byte alignment */
        incr  = 1;
        i     = 2;
        break;
      case enum_type_sized:
        size  = VTABLE_get_integer_keyed_int(interp, p, 2);
        align = VTABLE_get_integer_keyed_int(interp, p, 3);
        incr  = 3;
        i     = 4;
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Unknown struct type `%Ss'",
                Parrot_dt_get_datatype_name(interp, pack_type));
    }

    if (init_len < n_elts + i)
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Initializer too short (%d) for struct type `%Ss' with %d elements",
                init_len,
                Parrot_dt_get_datatype_name(interp, pack_type),
                n_elts);

    elt_ary = mem_gc_allocate_n_zeroed_typed(interp, n_elts, elt_desc_t);
    PObj_custom_destroy_SET(_self);

    SETATTR_StructView_pack_type(interp, _self, pack_type);
    SETATTR_StructView_elts(interp,      _self, elt_ary);
    SETATTR_StructView_n_elts(interp,    _self, n_elts);

    for (/* i already initialized */ j = 0; i < init_len && j < n_elts; i += incr, j++) {
        elt_desc_t * const elt = &elt_ary[j];
        const PARROT_DATA_TYPE elt_type = (PARROT_DATA_TYPE)
                                        VTABLE_get_integer_keyed_int(interp, p, i);
        size_t            elt_size, elt_align;
        elt_access_t      elt_access;

        if (elt_type < enum_first_type || enum_last_type <= elt_type)
            Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "Invalid type flag for struct element (%d)", elt_type);

        elt->type = elt_type;
        elt_size  = data_types[elt_type - enum_first_type].size;
        elt_align = data_types[elt_type - enum_first_type].align;

        switch (elt_type) {
          /* aligned integer types */
          case enum_type_INTVAL:
          case enum_type_char:
          case enum_type_short:
          case enum_type_int:
          case enum_type_long:
#if PARROT_HAS_LONGLONG
          case enum_type_longlong:
#endif
          case enum_type_int8:
          case enum_type_int16:
          case enum_type_int32:
#if PARROT_HAS_INT64
          case enum_type_int64:
#endif
          case enum_type_uchar:
          case enum_type_ushort:
          case enum_type_uint:
          case enum_type_ulong:
#if PARROT_HAS_LONGLONG
          case enum_type_ulonglong:
#endif
          case enum_type_uint8:
          case enum_type_uint16:
          case enum_type_uint32:
#if PARROT_HAS_INT64
          case enum_type_uint64:
#endif

            elt_access = int_access;
            break;

          /* unaligned integer types */
          case enum_type_uint1:
          case enum_type_uint4:
            elt_access = unaligned_access;
            break;

          /* float types */
          case enum_type_FLOATVAL:
          case enum_type_float:
          case enum_type_double:
          case enum_type_longdouble:
            elt_access = num_access;
            break;

          /* other types */
          case enum_type_STRING:
            elt_access = str_access;
            break;
          case enum_type_sized:
            /* arbitrary buffers extended with size and align fields */
            elt->size = elt_size = VTABLE_get_integer_keyed_int(interp, p, ++i);
            elt_align            = VTABLE_get_integer_keyed_int(interp, p, ++i);
            /* fallthrough */
          case enum_type_PMC:
          case enum_type_ptr:
          case enum_type_func_ptr:
            elt_access = pmc_access;
            break;

          /* locally unsupported types */
#if !PARROT_HAS_LONGLONG
          case enum_type_longlong:
          case enum_type_ulonglong:
#endif
#if !PARROT_HAS_INT64
          case enum_type_int64:
          case enum_type_uint64:
#endif
            Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "Unsupported struct element type `%Ss' (index %d)",
                    Parrot_dt_get_datatype_name(interp, elt_type),
                    j);

          default:
            Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "Unknown struct element type `%s' (index %i)",
                    Parrot_dt_get_datatype_name(interp, elt_type),
                    j);
        }

        switch (pack_type) {
          case enum_type_struct:
            elt->access = elt_access;
            align       = MAX(align, elt_align);
            switch (elt_access) {
              case int_access:
              case num_access:
              case pmc_access:
                if (bit_cursor) {
                    byte_cursor += 1;
                    bit_cursor   = 0;
                }
                elt->byte_offset = ALIGN_UP(byte_cursor, elt_align);
                byte_cursor      = elt->byte_offset + elt_size;
                break;
              case unaligned_access:
                elt->byte_offset = byte_cursor;
                elt->bit_offset  = bit_cursor;
                byte_cursor      = (bit_cursor + 1) / 8;
                bit_cursor       = (bit_cursor + 1) % 8;
                break;
              default:
                  break;
            }
            break;
          case enum_type_union:
            elt->access = elt_access;
            size        = MAX(size,  elt_size);
            align       = MAX(align, elt_align);
            /* all union elements are at 0 offset */
            break;
          case enum_type_sized:
            elt->byte_offset = VTABLE_get_integer_keyed_int(interp, p, i + 1);
            elt->bit_offset  = VTABLE_get_integer_keyed_int(interp, p, i + 2);
            switch (elt_access) {
              case num_access:
              case str_access:
              case pmc_access:
                if (align < elt_align
                ||  elt->bit_offset
                ||  elt->byte_offset % elt_align)
                    Parrot_ex_throw_from_c_args(interp, NULL, 0,
                            "Unaligned access unsupported on type `%Ss' (index: %i)",
                            Parrot_dt_get_datatype_name(interp, elt_type),
                            j);
                elt->access = elt_access;
                break;
              case int_access:
                if (align < elt_align
                ||  elt->bit_offset
                ||  elt->byte_offset % elt_align) {
                    switch (elt_type) {
                      case enum_type_uchar:
                      case enum_type_ushort:
                      case enum_type_uint:
                      case enum_type_ulong:
#if PARROT_HAS_LONGLONG
                      case enum_type_ulonglong:
#endif
                      case enum_type_uint8:
                      case enum_type_uint16:
                      case enum_type_uint32:
#if PARROT_HAS_INT64
                      case enum_type_uint64:
#endif
                        elt->access = unaligned_access;
                        break;
                      default:
                        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                                "Unaligned access unsupported on type `%Ss' (index: %i)",
                                Parrot_dt_get_datatype_name(interp, elt_type),
                                j);
                    }
                }
                else {
                    elt->access = int_access;
                }
                break;
              case unaligned_access:
                elt->access = unaligned_access;
                break;
              default:
                  break;
            }
          default:
              break;
        }
    }

    if (pack_type == enum_type_struct) {
        size = byte_cursor + !!bit_cursor;
    }

    SETATTR_StructView_align(interp, _self, align);
    SETATTR_StructView_size(interp, _self, size);
#line 1093 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, INTVAL x)
{
#line 536 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case int_access:
        switch (elts[i].type) {
#define CASE_SET2(type, name) \
          case enum_type_  ## name: *(type *)ptr = x; return;
#define CASE_SET1(type) \
            CASE_SET2(type, type) \
            CASE_SET2(unsigned type, u ## type)
            CASE_SET2(INTVAL, INTVAL)
            CASE_SET1(char);
            CASE_SET1(short);
            CASE_SET1(int);
            CASE_SET1(long);
#if PARROT_HAS_LONGLONG
            CASE_SET2(long long,          longlong);
            CASE_SET2(unsigned long long, ulonglong);
#endif
            CASE_SET2(Parrot_Int1,  int8);
            CASE_SET2(Parrot_UInt1, uint8);
            CASE_SET2(Parrot_Int2,  int16);
            CASE_SET2(Parrot_UInt2, uint16);
            CASE_SET2(Parrot_Int4,  int32);
            CASE_SET2(Parrot_UInt4, uint32);
#if PARROT_HAS_INT64
            CASE_SET2(Parrot_Int8,  int64);
            CASE_SET2(Parrot_UInt8, uint64);
#endif
#undef CASE_SET1
#undef CASE_SET2
          default:
              break;
        }
        break;
      case unaligned_access:
        {
            UINTVAL        ux = x;
            size_t         bits, n;
            unsigned char  tempc;
            unsigned char *cptr = (unsigned char *)ptr;

            switch (elts[i].type) {
              case enum_type_uint1:
                bits = 1;
                break;
              case enum_type_uint4:
                bits = 4;
                break;
              default:
                bits = 8 * data_types[elts[i].type - enum_first_type].size;
                break;
            }

            /* cache last byte (for restoring hi bits) */
            tempc    = cptr[(bits + elts[i].bit_offset)/8];

            /* write hi bits of first byte */
            n        = 8 - elts[i].bit_offset;
            *cptr   &= (1 << elts[i].bit_offset) - 1;
            *cptr++ |= (ux & (1 << n) - 1) << elts[i].bit_offset;

            /* write whole bytes until complete */
            while (n < bits) {
                *cptr++  = ux >> n;
                n       += 8;
            }

            /* restore hi bits of last byte */
            cptr--;
            n = 8 - (n - bits); /* how many bits of last byte we should have written */
            *cptr &=           (1 << n) - 1;
            *cptr |= tempc & ~((1 << n) - 1);
        }
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid integer type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 1179 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, FLOATVAL n)
{
#line 653 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case num_access:
        switch (elts[i].type) {
          case enum_type_FLOATVAL:
            *(FLOATVAL *)ptr    = n;
            return;
          case enum_type_float:
            *(float *)ptr       = n;
            return;
          case enum_type_double:
            *(double *)ptr      = n;
            return;
          case enum_type_longdouble:
            *(long double *)ptr = n;
            return;
          default:
              break;
        }
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid number type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 1210 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, PMC *p)
{
#line 774 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case int_access:
      case unaligned_access:
        VTABLE_set_integer_keyed(interp, _self, k, VTABLE_get_integer(interp, p));
        break;
      case num_access:
        VTABLE_set_number_keyed(interp, _self, k, VTABLE_get_number(interp, p));
        break;
      case str_access:
        VTABLE_set_string_keyed(interp, _self, k, VTABLE_get_string(interp, p));
        break;
      case pmc_access:
        {
            switch (elts[i].type) {
              case enum_type_PMC:
                *(PMC **)ptr = p;
                break;
              case enum_type_func_ptr:
              case enum_type_ptr:
                *(void **)ptr = VTABLE_get_pointer(interp, p);
                break;
              case enum_type_sized:
                if (VTABLE_does(interp, p, CONST_STRING(interp, "buffer"))) {
                    void   *q  = VTABLE_get_pointer(interp, p);
                    size_t len = VTABLE_get_integer(interp, p);
                    if (!len || len > elts[i].size)
                        len = elts[i].size;
                    memcpy(ptr, q, len);
                    break;
                }
                else {
                    Parrot_ex_throw_from_c_args(interp, NULL, 0,
                            "Type `%Ss' unsuitable for buffer assignment",
                            p->vtable->whoami);
                }
              default:
                  break;
            }
        }
      default:
          break;
    }
#line 1260 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_set_string_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *k, STRING *s)
{
#line 709 "./src/pmc/structview.pmc"

    BEGIN_KEYED(interp, _self, k)
    switch (elts[i].access) {
      case str_access:
        switch (elts[i].type) {
          case enum_type_STRING:
            *(STRING **)ptr = s;
            return;
          default:
              break;
        }
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
                "Not a valid string type (`%Ss')",
                Parrot_dt_get_datatype_name(interp, elts[i].type));
    }
#line 1282 "./src/pmc/structview.c"
}
static  void 
Parrot_StructView_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *v)
{
#line 1095 "./src/pmc/structview.pmc"

    PMC *shape = Parrot_pmc_new_noinit(interp, enum_class_ResizableIntegerArray);
    VTABLE_thaw(interp, shape, v);
    VTABLE_init_pmc(interp, _self, shape);
#line 1292 "./src/pmc/structview.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StructView_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_StructView_destroy;
    vt->freeze = Parrot_StructView_freeze;
    vt->get_integer = Parrot_StructView_get_integer;
    vt->get_integer_keyed = Parrot_StructView_get_integer_keyed;
    vt->get_number_keyed = Parrot_StructView_get_number_keyed;
    vt->get_pmc_keyed = Parrot_StructView_get_pmc_keyed;
    vt->get_string_keyed = Parrot_StructView_get_string_keyed;
    vt->init = Parrot_StructView_init;
    vt->init_pmc = Parrot_StructView_init_pmc;
    vt->set_integer_keyed = Parrot_StructView_set_integer_keyed;
    vt->set_number_keyed = Parrot_StructView_set_number_keyed;
    vt->set_pmc_keyed = Parrot_StructView_set_pmc_keyed;
    vt->set_string_keyed = Parrot_StructView_set_string_keyed;
    vt->thaw = Parrot_StructView_thaw;
    vt->attr_size = sizeof(Parrot_StructView_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StructView_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_StructView_destroy;
    vt->freeze = Parrot_StructView_freeze;
    vt->get_integer = Parrot_StructView_get_integer;
    vt->get_integer_keyed = Parrot_StructView_get_integer_keyed;
    vt->get_number_keyed = Parrot_StructView_get_number_keyed;
    vt->get_pmc_keyed = Parrot_StructView_get_pmc_keyed;
    vt->get_string_keyed = Parrot_StructView_get_string_keyed;
    vt->attr_size = sizeof(Parrot_StructView_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StructView_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_StructView_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StructView_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_StructView_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StructView_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "StructView", 10,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StructView_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StructView")), PMCNULL);
    return isa;
}

void
Parrot_StructView_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":pack_type :n_elts :elts :align :size ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StructView_get_vtable(interp);
        vt->base_type      = enum_class_StructView;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StructView");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StructView_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_StructView_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_StructView;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StructView_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "size");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_size),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "align");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_align),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "aligned_size");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_aligned_size),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "alloc");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_alloc),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "array_offs");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_array_offs),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "elt_offs");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_elt_offs),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_shape");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StructView_nci_get_shape),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_StructView_class_init */
#line 1099 "./src/pmc/structview.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */

