/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/threadinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_threadinterpreter.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "threadinterpreter.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/threadinterpreter.pmc"
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/threadinterpreter.pmc - INTERNAL Interpreter for OS level worker thread(pthread).

=head1 DESCRIPTION

ThreadInterpreter extends ParrotInterpreter to provide a interpreter
to be used internally in a OS level worker thread(pthread).
which supports:

=head2 Methods

=over 4

=cut

*/

#include "parrot/embed.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void stop_GC(ARGMOD(Interp *parent), ARGMOD(Interp *thread))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*parent)
        FUNC_MODIFIES(*thread);

#define ASSERT_ARGS_stop_GC __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(parent) \
    , PARROT_ASSERT_ARG(thread))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp

/*
 * can't do multi-threaded GC yet
 * XXX a quick hack to pass the few tests
 */

/*

=item C<static void stop_GC(Interp *parent, Interp *thread)>

stop GC running - multi-threaded GC is not available yet

=cut

*/

static void
stop_GC(ARGMOD(Interp *parent), ARGMOD(Interp *thread))
{
    ASSERT_ARGS(stop_GC)
    Parrot_block_GC_mark(parent);
    Parrot_block_GC_mark(thread);
    Parrot_block_GC_sweep(parent);
    Parrot_block_GC_sweep(thread);
}
#line 89 "./src/pmc/threadinterpreter.c"
static  void  Parrot_ThreadInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ThreadInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_ThreadInterpreter_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ThreadInterpreter_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ThreadInterpreter_get_vtable(PARROT_INTERP);
void    Parrot_ThreadInterpreter_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ThreadInterpreter_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ThreadInterpreter_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_ThreadInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_ThreadInterpreter_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ThreadInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 81 "./src/pmc/threadinterpreter.pmc"

    /* protect interpreter creation and list handling */
    LOCK(interpreter_array_mutex);

    interp->vtables[enum_class_ParrotInterpreter]->init(interp, _self);
    pt_add_to_interpreters(interp, PMC_interp(_self));

    UNLOCK(interpreter_array_mutex);

    /* can't allow GC runs for now */
    stop_GC(interp, PMC_interp(_self));
#line 119 "./src/pmc/threadinterpreter.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ThreadInterpreter_update_vtable(VTABLE *vt) {
    vt->init = Parrot_ThreadInterpreter_init;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ThreadInterpreter_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ThreadInterpreter_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_ParrotInterpreter_get_vtable(interp);
    Parrot_ThreadInterpreter_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ThreadInterpreter_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_ParrotInterpreter_ro_get_vtable(interp);
    Parrot_ThreadInterpreter_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ThreadInterpreter_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_ParrotInterpreter_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "ThreadInterpreter", 17,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ThreadInterpreter_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_ParrotInterpreter_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ThreadInterpreter")), PMCNULL);
    return isa;
}

void
Parrot_ThreadInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ThreadInterpreter_get_vtable(interp);
        vt->base_type      = enum_class_ThreadInterpreter;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ThreadInterpreter");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_ThreadInterpreter_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ThreadInterpreter_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ThreadInterpreter;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ThreadInterpreter_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ThreadInterpreter_class_init */
#line 92 "./src/pmc/threadinterpreter.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
